<?php

if (!defined('IN_AJAX')) die(basename(__FILE__));

global $lang, $bb_cfg;

$mode = $this->request['mode'];
$data = $this->request['data'];
$html = $search_result = '';

function searchCheck ($search, $minSymvol = 5, $maxSymvol = 128, $maxWords= 10)
{
	if (mb_strlen($search, 'UTF-8') < $minSymvol) 
	{
		bb_die('Слишком короткий поисковый запрос.');
	}
	$search = strip_tags($search);
	//$search = mb_strtolower(trim($search), 'UTF-8'); //Преобразуем в нижний регистр и переводим кирилицу в UTF
	$search = trim($search); //Преобразуем в нижний регистр
	$search = preg_replace('~[^a-z0-9 \x80-\xFF]~i', "",$search); //Удаляем не нужные символы
	$search = encode_text_match($search);
	$search = preg_replace("/[\s]([^\s]{1,$minSymvol})[\s]/", " ", str_replace(" ", "  ", " ".$search." ")); //Удаление коротких слов
	$search = preg_replace('/ {2,}/',' ',$search); // убираем повторяющиеся пробелы 
	$search = substr($search, 0, $maxSymvol); //Ограничение на символы
	$search = limit_words($search, $maxWords); //Ограничение на кол-во слов
	if (mb_strlen($search, 'UTF-8') < $minSymvol) 
	{
		bb_die('Слишком короткий поисковый запрос.');
	}
	return trim($search);
}

switch ($mode)
{	
	case 'Topic':
		if (isset($data)) 
		{
			@$type = (int) $this->request['type'] ? $this->request['type'] : 0;
			$limit = $type * 5;
			$max_result = '11';
			$Result = searchCheck($data, 3);
			$Result = explode(" ", $Result);
			foreach ($Result as $key => $value) {
				$dataResult[] = '+'.$value.'*';
			}
			$search = implode(" ", $dataResult);

			$sql = DB()->fetch_rowset("
					SELECT topic_id, topic_title
					FROM ".BB_TOPICS."
					WHERE MATCH (topic_title) AGAINST ('". $search ."' IN BOOLEAN MODE)
					LIMIT $limit,$max_result
					");
			$replace = array(
				'  ' => '',
				' ' => '|'
			);
			$titleR = searchCheck($data, 3);
			$titleR = str_replace(array_keys($replace), array_values($replace), $titleR);
			foreach($sql as $row)
			{
				$title = preg_replace('/' .$titleR. '/iu', '<font color="red">\\0</font>', $row['topic_title']);
				$search_result .= '<a href="viewtopic.php?t='.$row['topic_id'].'"><span align="left" class="searchheading"><b>'.$title.'</b></span></a><hr><div class="spacer_1 row3"></div>';
			}
			if (empty($search_result)) 
			{
				$search_result = '<span class="notfound">'.$lang['AJAX_SEARCH_NULL_RESULT'].'</span>';
				$ShowRightButton = true;
			}
		}else{
			$search_result = '<span class="notfound">'.$lang['AJAX_SEARCH_NO_NAME'].'</span>';
		}
		$html .= '<div class="spacer"></div>';
		$html .= '<div class="spacer_4"></div>';
		$html .= '<table id="'.$data.'">';
		$html .= '<tr><td class="w100" align="Center" colspan="2">';
		$html .= ''.$search_result.'';
		$html .= '</td></tr><tr>';
		$html .= ($type) ? '<td width="10%" align="left"><a title="Предыдущие '.$max_result.' тем" href="#" onclick="ajax.exec({action : \'QuickSearch\', mode: \'Topic\', data: \''.$data.'\', type: '. ($type - 1) .'}); return false;"><<<</a></td>' : '';
		$html .= empty($ShowRightButton) ? '<td width="100%" align="right"><a title="Следующие '.$max_result.' тем" href="#" onclick="ajax.exec({action : \'QuickSearch\', mode: \'Topic\', data: \''.$data.'\', type: '. ($type + 1) .'}); return false;">>>></a></td>' : '';
		$html .= '</tr></table>';
	break;
	
	case 'Queries':
		if (isset($data)) 
		{
			$max_result = '10';
			$search = CACHE('bb_cache')->get('queries_'.md5($data));
 
			if ($search != '')
			{
				$search_result .= json_decode($search);
			}else{
				$sql = "
						SELECT * 
						FROM ".BB_QUERIES." 
						WHERE query LIKE '%".DB()->escape($data)."%' 
						ORDER BY hit DESC LIMIT $max_result";
				if(!$result = DB()->sql_query($sql))
				{
					$this->ajax_die('ERROR QUERIES');
				}
			 
				while ($row = DB()->sql_fetchrow($result))
				{
					$search[] = $row['query'];
				}
				if (empty($search_result)) 
				{
					$search_result[] = $data;
				}else{			 
					CACHE('bb_cache')->set('queries_'.md5($data), json_encode($search), 300);
					$search_result .= $search;
				}				
			}
		}else{
			$search_result[] = $lang['AJAX_SEARCH_NO_NAME'];
		}	
		$this->response['tagOn'] = true;
		$this->response['tag'] = $search_result;
	break;
	
	case 'UserName':
		if (isset($data)) 
		{
			$max_result = '11';
			$Result = searchCheck($data, 1);
			$Result = explode(" ", $Result);
			foreach ($Result as $key => $value) {
				$dataResult[] = '+'.$value.'*';
			}
			$search = implode(" ", $dataResult);
			
			$username_search = preg_replace('/\*/', '%', clean_username($data));

			$sql = DB()->fetch_rowset("
				SELECT username
				FROM ". BB_USERS ."
				WHERE MATCH (username) AGAINST ('". $search ."' IN BOOLEAN MODE)
					AND user_id <> ". ANONYMOUS ."
				ORDER BY username
				LIMIT 0,$max_result
			");
			
			foreach ($sql as $row)
			{
				$username = htmlCHR(stripslashes(html_entity_decode($row['username'])));
				$search_result[] = $username;
			}
		}else{
			$search_result .= $lang['AJAX_SEARCH_NO_NAME'];
		}	
		$this->response['tagOn'] = true;
		$this->response['tag'] = $search_result;
	break;
		
	default:
		$this->ajax_die($lang['SELECT_A_MODE']);
	break;
}
$this->response['html'] = $html;

